! $Id: bin2asc.s,v 1.1 2003/07/17 00:43:46 chris Exp $
!
! binary to ASCII conversion routines for Intel i860
! (c) Copyright 2003 by Christian Groessler, chris@groessler.org
!
! This program is free software; you can redistribute it and/or
! modify it under the terms of the GNU General Public License
! as published by the Free Software Foundation; either version 2
! of the License, or (at your option) any later version.
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with this program; if not, write to the Free Software
! Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 
! 02111-1307, USA.

	.text
	.globl	hex32, hex16, hex8


!*****************************************************************************
!* Unterprogramm:	HEX32						     *
!* Aufgabe:		32-bit Binrzahl in String wandeln (hexadezimal)     *
!* bergabe:		r17 - Zeiger auf 8-byte Zielpuffer		     *
!*			r16 - zu wandelnde Zahl				     *
!* Zurck:		r17 - Zeiger hinter Hexstring			     *
!* Benutzt:		HEX16						     *
!*									     *
!* alle Register (auer r16) erhalten					     *
!*****************************************************************************

hex32:
	adds	-8,%sp,%sp
	st.l	%r16,4(%sp)		! save data value
	st.l	%r1,0(%sp)		! save return address

	call	hex16
	 shr	16,%r16,%r16

	ld.l	0(%sp),%r1
	ld.l	4(%sp),%r16
	adds	8,%sp,%sp
	!fall into hex16


!*****************************************************************************
!* Unterprogramm:	HEX16						     *
!* Aufgabe:		16-bit Binrzahl in String wandeln (hexadezimal)     *
!* bergabe:		r17 - Zeiger auf 4-byte Zielpuffer		     *
!*			r16 - zu wandelnde Zahl				     *
!* Zurck:		r17 - Zeiger hinter Hexstring			     *
!* Benutzt:		HEX8						     *
!*									     *
!* alle Register (auer r16) erhalten					     *
!*****************************************************************************

hex16:
	adds	-8,%sp,%sp
	st.l	%r16,4(%sp)		! save data value
	st.l	%r1,0(%sp)		! save return address

	call	hex8
	 shr	8,%r16,%r16

	ld.l	0(%sp),%r1
	ld.l	4(%sp),%r16
	adds	8,%sp,%sp
	!fall into hex8


!*****************************************************************************
!* Unterprogramm:	HEX8						     *
!* Aufgabe:		8-bit Binrzahl in String wandeln (hexadezimal)      *
!* bergabe:		r17 - Zeiger auf 2-byte Zielpuffer		     *
!*			r16 - zu wandelnde Zahl				     *
!* Zurck:		r17 - Zeiger hinter Hexstring			     *
!*									     *
!* alle Register (auer r16) erhalten					     *
!*****************************************************************************

hex8:
	adds	-8,%sp,%sp
	st.l	%r18,4(%sp)		! scratch register
	st.l	%r16,0(%sp)		! data value

	and	255,%r16,%r16
	shr	4,%r16,%r16		! upper nibble

	mov	10,%r18
	subu	%r16,%r18,%r0		! compare data value with 10

	bnc.t	hex8_1			! smaller
	 addu	'0',%r16,%r16		! (not executed if not branched)

	addu	'A'-10,%r16,%r16	! larger

hex8_1:	st.b	%r16,0(%r17)		! store first digit
	addu	1,%r17,%r17

	ld.l	0(%sp),%r16		! get data value again
	and	15,%r16,%r16		! lower nibble

	subu	%r16,%r18,%r0		! compare data value with 10

	bnc.t	hex8_2			! smaller
	 addu	'0',%r16,%r16		! (not executed if not branched)

	addu	'A'-10,%r16,%r16	! larger

hex8_2:	st.b	%r16,0(%r17)		! store 2nd digit
	addu	1,%r17,%r17
	ld.l	4(%sp),%r18		! restore scratch register
	bri	%r1			! return
	 adds	8,%sp,%sp		! adjust sp

	.end
