# $Id: fullscr.s,v 1.2 2004/02/28 01:48:39 chris Exp $
# fill screen memory with garbage

screen_base = 0xb8000		# CGA/EGA/VGA


iobase = 0xc2000000

		.text

# startup, called from stub reset handler at 0xffffff00

		.globl		_start

_start:		st.c		%r0,%psr
		st.c		%r0,%fsr
		ld.c		%fir,%r0

# clear pipeline

		pfadd.ss	%f0,%f0,%f0
		pfadd.ss	%f0,%f0,%f0
		pfadd.ss	%f0,%f0,%f0
		pfmul.ss	%f0,%f0,%f0
		pfmul.ss	%f0,%f0,%f0
		pfmul.ss	%f0,%f0,%f0

		mov		iobase,%r15
		mov		0x01,%r16
		st.b		%r16,0x80(%r15)

		call		flush_cache
		 nop

		mov		0x02,%r16
		st.b		%r16,0x80(%r15)

		mov		stack,%r16
		mov		%r16,%r2		# set up stack

		mov		0x03,%r16
		st.b		%r16,0x80(%r15)		# write 03 to port 80h

		br		my_main			# jump to main program
		 nop

FLUSH_P = 0x7f000000 - 32

		.align	16
flush_cache:	mov		%r1,%r2
		ld.c		%dirbase,%r27	# ???
		or		0x800,%r27,%r27
		adds		-1,%r0,%r25
		call		D_FLUSH
		 st.c		%r27,%dirbase

		or		0x900,%r27,%r27
		call		D_FLUSH
		 st.c		%r27,%dirbase

		xor		0x900,%r27,%r27
		mov		%r2,%r1
		bri		%r1
		 st.c		%r27,%dirbase

D_FLUSH:	or		(FLUSH_P&0xffff),%r0,%r24
		orh		(FLUSH_P>>16),%r24,%r24
		or		127,%r0,%r26
		bla		%r25,%r26,D_FLUSH_LOOP
		 ld.l		32(%r24),%r0

		.align	16

D_FLUSH_LOOP:	ixfr		%r0,%f0
		bla		%r25,%r26,D_FLUSH_LOOP
		 flush		32(%r24)++
		ixfr		%r0,%f0

		bri		%r1
		 ld.l		-512(%r24),%r0


		.align	16

#
# start of real program....
#

# fill display memory with patterns, 32K

LENGTH	=	16384				# number of words

my_main:	mov	0x730,%r22		# ascii "0" and attribute 7
		mov	LENGTH,%r20
		mov	screen_base,%r24	# pointer to screen memory

		.align	16
disploop:	mov	%r20,%r19		# r19: loop counter
		mov	%r24,%r25		# r25: current pointer into screen

		.align	16
onefill:	st.s	%r22,0(%r25)
		addu	2,%r25,%r25		# point to next screen memory
		adds	-1,%r19,%r19
		btne	%r0,%r19,onefill

		mov	%r22,%r21		# move into scratch register
		addu	1,%r21,%r21		# increment
		and	255,%r21,%r21
		mov	0x3A,%r26
		subu	%r21,%r26,%r0		# compare with 0x3A

		bnc.t	valok
		 nop				# (not executed if not branched)

		mov	0x30,%r21

valok:		and	0xff00,%r22,%r22
		or	%r22,%r21,%r22

		call	delay
		 nop

		br	disploop		# never end


# delay routine

delay_count	=	4000000

delay:		mov	-1,%r5
		mov	delay_count,%r6
		bla	%r5,%r6,delay_loop
		 nop

delay_loop:	bla	%r5,%r6,delay_loop
		 nop

		bri		%r1
		 nop


		.section	.bss

		.align		2
		.ds.l		256
stack:		.ds.l		1

		.end
