# heartbeat demo from Hauppauge 4860 motherboard docs

screen_base = 0xb8000		# CGA (cpg)
#screen_base = 0xb0000		# MDA
screen_offs = 160 - 8

delay_count = 1000000
iobase = 0xc2000000

# .atmp r31   # always r31 in ATT syntax
.text

	nop

	.globl		_start
_start:

	st.c		%r0,%psr
	st.c		%r0,%fsr
	ld.c		%fir,%r0

# clear pipeline

	pfadd.ss	%f0,%f0,%f0
	pfadd.ss	%f0,%f0,%f0
	pfadd.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0

	mov		iobase,%r15
	mov		0x01,%r16
	st.b		%r16,0x80(%r15)

	call		flush_cache
	 nop

	mov		0x02,%r16
	st.b		%r16,0x80(%r15)

	mov		%r0,%r2

	mov		screen_base,%r18		# set up screen

	mov		0x03,%r16
	st.b		%r16,0x80(%r15)			# write 03 to port 80h

loop:
	call		delay
	 nop

	mov		0x072a,%r16
	st.b		%r16,0x80(%r15)
	st.s		%r16,screen_offs(%r18)		# *
	mov		0x0720,%r16
	st.s		%r16,screen_offs+2(%r18)	# space

	call		delay
	 nop

	mov		0x0720,%r16
	st.b		%r16,0x80(%r15)
	st.s		%r16,screen_offs(%r18)		# space
	mov		0x072a,%r16
	st.s		%r16,screen_offs+2(%r18)	# *

	br		loop
	 nop

delay:
	mov		-1,%r5
	mov		delay_count,%r6
	bla		%r5,%r6,delay_loop
	 nop

delay_loop:
	bla		%r5,%r6,delay_loop
	 nop

	bri		%r1
	 nop

.align	16		# original: .align .quad

flush_cache:

FLUSH_P = 0x7f000000 - 32

	mov		%r1,%r2
	ld.c		%dirbase,%r27	# ???
	or		0x800,%r27,%r27
	adds		-1,%r0,%r25
	call		D_FLUSH
	 st.c		%r27,%dirbase

	or		0x900,%r27,%r27
	call		D_FLUSH
	 st.c		%r27,%dirbase
	
	xor		0x900,%r27,%r27
	mov		%r2,%r1
	bri		%r1
	 st.c		%r27,%dirbase

D_FLUSH:
	or		(FLUSH_P&0xffff),%r0,%r24
	orh		(FLUSH_P>>16),%r24,%r24
	or		127,%r0,%r26
	bla		%r25,%r26,D_FLUSH_LOOP
	 ld.l		32(%r24),%r0

.align	16			# original: .align .quad

D_FLUSH_LOOP:
	
	ixfr		%r0,%f0
	bla		%r25,%r26,D_FLUSH_LOOP
	 flush		32(%r24)++
#	.long		0x37000021
	ixfr		%r0,%f0

	bri		%r1
	 ld.l		-512(%r24),%r0

	.end

