# $Id: hextest.s,v 1.2 2003/08/18 22:37:29 chris Exp $
# test hex routines

screen_base = 0xb8000		# CGA (cpg)
screen_offs = 160 - 16

#delay_count = 1000000
iobase = 0xc2000000

#	.atmp		r31		# always r31 in ATT syntax
	.text

# startup after reset...

	st.c		%r0,%psr
	st.c		%r0,%fsr
	ld.c		%fir,%r0

# clear pipeline

	pfadd.ss	%f0,%f0,%f0
	pfadd.ss	%f0,%f0,%f0
	pfadd.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0

	mov		iobase,%r15
	mov		0x01,%r16
	st.b		%r16,0x80(%r15)

	call		flush_cache
	 nop

	mov		0x02,%r16
	st.b		%r16,0x80(%r15)

#	mov		%r0,%r2
	mov		stack,%r2

	mov		screen_base,%r18		# set up screen

	mov		0x03,%r16
	st.b		%r16,0x80(%r15)			# write 03 to port 80h

	br		do_work
	 nop

.align	16		# original: .align .quad

flush_cache:

FLUSH_P = 0x7f000000 - 32

	mov		%r1,%r2
	ld.c		%dirbase,%r27	# ???
	or		0x800,%r27,%r27
	adds		-1,%r0,%r25
	call		D_FLUSH
	 st.c		%r27,%dirbase

	or		0x900,%r27,%r27
	call		D_FLUSH
	 st.c		%r27,%dirbase
	
	xor		0x900,%r27,%r27
	mov		%r2,%r1
	bri		%r1
	 st.c		%r27,%dirbase

D_FLUSH:
	or		(FLUSH_P&0xffff),%r0,%r24
	orh		(FLUSH_P>>16),%r24,%r24
	or		127,%r0,%r26
	bla		%r25,%r26,D_FLUSH_LOOP
	 ld.l		32(%r24),%r0

.align	16			# original: .align .quad

D_FLUSH_LOOP:
	
	ixfr		%r0,%f0
	bla		%r25,%r26,D_FLUSH_LOOP
	 flush		32(%r24)++
	ixfr		%r0,%f0

	bri		%r1
	 ld.l		-512(%r24),%r0


.align	16

# real start of program....

do_work:
	mov		hexbuf,%r17
	mov		0x12345678,%r16
#	mov		0xbeefbabe,%r16
	call		hex32
	 nop
	st.b		%r0,0(%r17)

	call		print_hexbuf
	 nop

#	mov		hexbuf,%r17
#	mov		0xbeefbabe,%r16
#	call		hex16
#	 nop
#	st.b		%r0,0(%r17)

#	call		print_hexbuf
#	 nop



finish:	br		finish
	 nop

.align	16

print_hexbuf:

	adds		-16,%sp,%sp
	st.l		%r19,12(%sp)
	st.l		%r18,8(%sp)
	st.l		%r17,4(%sp)
	st.l		%r16,0(%sp)

	mov		screen_base,%r18
	mov		hexbuf,%r17
	mov		0x700,%r19		# attribute
prloo:	ld.b		0(%r17),%r16
	bte		%r0,%r16,prdone
	or		%r19,%r16,%r16
	st.s		%r16,screen_offs(%r18)
	addu		1,%r17,%r17
	br		prloo
	 addu		2,%r18,%r18

prdone:
	ld.l		0(%sp),%r16
	ld.l		4(%sp),%r17
	ld.l		8(%sp),%r18
	ld.l		12(%sp),%r19
	
	bri		%r1
	 adds		16,%sp,%sp


	.data

hexbuf:	.asciz		"Fred is bled!"
	.ds.b		10


	.ds.l		1024
stack:	.ds.l		1

	.end

