# $Id: memwatch.s,v 1.6 2003/08/18 22:30:51 chris Exp $
# live memory display

screen_base = 0xb8000		# CGA/EGA/VGA


iobase = 0xc2000000

#	.atmp		r31		# always r31 in ATT syntax
	.text

# startup, called from stub reset handler at 0xffffff00

	st.c		%r0,%psr
	st.c		%r0,%fsr
	ld.c		%fir,%r0

# clear pipeline

	pfadd.ss	%f0,%f0,%f0
	pfadd.ss	%f0,%f0,%f0
	pfadd.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0
	pfmul.ss	%f0,%f0,%f0

	mov		iobase,%r15
	mov		0x01,%r16
	st.b		%r16,0x80(%r15)

	call		flush_cache
	 nop

	mov		0x02,%r16
	st.b		%r16,0x80(%r15)

	mov		stack,%r16
	mov		%r16,%r2			# set up stack

	mov		screen_base,%r18		# set up screen

	mov		0x03,%r16
	st.b		%r16,0x80(%r15)			# write 03 to port 80h

	br		_my_main
	 nop

	.align	16
flush_cache:

FLUSH_P = 0x7f000000 - 32

	mov		%r1,%r2
	ld.c		%dirbase,%r27	# ???
	or		0x800,%r27,%r27
	adds		-1,%r0,%r25
	call		D_FLUSH
	 st.c		%r27,%dirbase

	or		0x900,%r27,%r27
	call		D_FLUSH
	 st.c		%r27,%dirbase

	xor		0x900,%r27,%r27
	mov		%r2,%r1
	bri		%r1
	 st.c		%r27,%dirbase

D_FLUSH:
	or		(FLUSH_P&0xffff),%r0,%r24
	orh		(FLUSH_P>>16),%r24,%r24
	or		127,%r0,%r26
	bla		%r25,%r26,D_FLUSH_LOOP
	 ld.l		32(%r24),%r0

	.align	16

D_FLUSH_LOOP:

	ixfr		%r0,%f0
	bla		%r25,%r26,D_FLUSH_LOOP
	 flush		32(%r24)++
	ixfr		%r0,%f0

	bri		%r1
	 ld.l		-512(%r24),%r0


	.align	16

#
# start of real program....
#

# what to monitor
STARTADR	=	0x400
LENGTH		=	0xc0

_my_main:
	mov		STARTADR,%r19
	mov		LENGTH,%r20
	mov		%r0,%r21		# index into screen memory
	mov		%r0,%r22		# ascii display index index
	mov		16,%r23

# 16 bytes loop
# first display the memory address...

loop16:	mov		hexbuf,%r17
	call		hex32			# convert to ASCII string
	 mov		%r19,%r16		# address

	mov		':',%r16		# add ":" after address
	st.b		%r16,0(%r17)
	addu		1,%r17,%r17
	mov		32,%r16			# add space char
	st.b		%r16,0(%r17)
	addu		1,%r17,%r17
	st.b		%r0,0(%r17)		# trailing 0 for disp routine

	call		disp
	 nop

	addu		20,%r21,%r21		# next screen index

# then the data...

loop:	mov		hexbuf,%r17
	call		hex8			# convert to ASCII string
	 ld.b		0(%r19),%r16		# byte from memory to display

	mov		32,%r16			# space char
	st.b		%r16,0(%r17)
	addu		1,%r17,%r17
	st.b		%r0,0(%r17)		# trailing 0

	call		disp			# display as hex
	 nop

	call		disp_ascii		# ascii display
	 ld.b		0(%r19),%r16		# byte from memory to display

	addu		6,%r21,%r21		# next screen index (3 chars, 3 attribs)
	addu		1,%r19,%r19		# point to next memory byte
	addu		2,%r22,%r22		# next ascii position
	adds		-1,%r20,%r20		# decrement counter
	bte		%r0,%r20,fini
	adds		-1,%r23,%r23		# decrement line counter
	btne		%r0,%r23,loop		# test for end of loop

# end of current data line, start new line

	mov		16,%r23
	addu		160 - 16 * 2,%r22,%r22	# udate ascii position for next line
	br		loop16
	 addu		160 - (10 + 16 * 3) * 2,%r21,%r21	# update hex pos. f. next line

# finished one round

fini:	call		flush_cache		# get 486 memory changes
	 nop
	br		_my_main		# loop finished, start over, forever
	 nop


	.align	16

# ASCIIZ string display routine
# displays contents of hexbuf
# r21 - offset into screen memory
# all registers preserved

disp:	adds		-16,%sp,%sp
	st.l		%r19,12(%sp)		# save registers
	st.l		%r18,8(%sp)
	st.l		%r17,4(%sp)
	st.l		%r16,0(%sp)

	mov		screen_base,%r18
	addu		%r18,%r21,%r18
	mov		hexbuf,%r17
	mov		0x700,%r19		# attribute
prloo:	ld.b		0(%r17),%r16
	bte		%r0,%r16,prdone
	and		255,%r16,%r16
	or		%r19,%r16,%r16
	st.s		%r16,0(%r18)
	addu		1,%r17,%r17
	br		prloo
	 addu		2,%r18,%r18

prdone:
	ld.l		0(%sp),%r16		# restore registers
	ld.l		4(%sp),%r17
	ld.l		8(%sp),%r18
	ld.l		12(%sp),%r19

	bri		%r1
	 adds		16,%sp,%sp


	.align	16

# ASCII byte display routine
# r22 - offset into screen memory (w/o offset)
# all registers preserved

disp_ascii:
	adds		-12,%sp,%sp
	st.l		%r19,8(%sp)		# save registers
	st.l		%r18,4(%sp)
	st.l		%r16,0(%sp)

	mov		screen_base,%r18
	addu		%r18,%r22,%r18
	mov		0x700,%r19		# attribute
	and		255,%r16,%r16
	or		%r19,%r16,%r16
	st.s		%r16,122(%r18)		# 122: display on the right side of the screen

	ld.l		0(%sp),%r16		# restore registers
	ld.l		4(%sp),%r18
	ld.l		8(%sp),%r19

	bri		%r1
	 adds		12,%sp,%sp


	.section	.bss

hexbuf:	.ds.b		24

	.align		2
	.ds.l		4096
stack:	.ds.l		1

	.end
